#include "../std.h"
#include "config.h"

char* default_config_file = DEFAULT_CONFIG_FILE;
char* default_config_file_rel = DEFAULT_CONFIG_FILE;
char* config_file = NULL;

bool config_close(ifstream &cfile) {
  cfile.close(); 
  return true;
}

bool config_open(ifstream &cfile) {
  char* nordugrid_loc = getenv("NORDUGRID_LOCATION");
  string config_name(default_config_file);
  if(config_file) {
    config_name=config_file;
  }
  else {  
    if(nordugrid_loc) {
      config_name=nordugrid_loc;
      config_name+=default_config_file_rel;
    };
  };
  return config_open(cfile,config_name);
}

bool config_open(ifstream &cfile,string &name) {
  cfile.open(name.c_str(),ifstream::in);
  return cfile.is_open();
}

string config_read_line(istream &cfile) {
  string rest("");
  for(;;) {
    if(cfile.eof()) {
      return rest;
    };
    {
      char buf[256]; buf[0]=0;
      istream_readline(cfile,buf,sizeof(buf));
      rest=buf;
    };
    int n=rest.find_first_not_of(" \t");
    if(n == string::npos) continue; /* empty string - skip */
    if(rest[n] == '#') continue; /* comment - skip */
    rest.erase(0,n);
    n=rest.find_last_not_of(" \t");
    if(n != string::npos) rest.erase(n+1,string::npos);
    break;
  };
  return rest;
}

string config_read_line(istream &cfile,string &rest) {
  for(;;) {
    if(cfile.eof()) {
      rest=""; return "";
    };
    {
      char buf[256];
      istream_readline(cfile,buf,sizeof(buf));
      rest=buf;
    };
    int n=rest.find_first_not_of(" \t");
    if(n == -1) continue; /* empty string - skip */
    if(rest[n] == '#') continue; /* comment - skip */
    break;
  };
  return config_next_arg(rest);
}

string config_next_arg(string &rest) {
  int n=rest.find_first_not_of(" \t");
  if(n == -1) n=rest.length();
  int nn=n;
  for(;;) {
    nn=rest.find_first_of(" \t\\",nn);
    if(nn == -1) { nn=rest.length(); break; }; /* argument takes whole line */
    if(rest[nn] == '\\') {
      if(rest.length() <= (nn+1)) break; /* backslash at end of string */
      rest.erase(nn,1); nn++; continue;
    };
    break;
  };
  string arg = rest.substr(n,nn-n);
//  n=rest.find_first_not_of(" \t",nn);
//  if(n==-1) n=rest.length();
//  rest=rest.substr(n);
  rest=rest.substr(nn);
  return arg;
}    

void config_strip(string &rest) {
  int n=rest.find_first_not_of(" \t",0);
  if(n>0) rest.erase(0,n);
}

