#include "../../std.h"

#include "../../misc/log_time.h"

#include "se_ns.h"
#include "se_ns_rc.h"
#include "se_ns_none.h"

SENameServer* create_ns(const char* contact,const char* se_url) {
  SENameServer* ns = NULL;
  if((contact == NULL) || (contact[0] == 0)) {
    odlog(0)<<"SE: 'none' nameserver"<<endl;
    ns = new SENameServerNone(contact,se_url);
  } else if(strncasecmp("rc://",contact,5) == 0) {
    odlog(0)<<"SE: ReplicaCatalog nameserver: "<<contact<<endl;
    ns = new SENameServerRC(contact,se_url);
  } else {
    odlog(0)<<"SE: unrecognized nameserver"<<endl;
  };
  if(ns) if(!(*ns)) { delete ns; ns=NULL; };
  if(!ns) { odlog(0)<<"SE: failed to create nameserver"<<endl; };
  return ns;
};

