#include "std.h"

#include "Xrsl.h"
#include "RemoteFile.h"

#ifndef UI_TARGET
#define UI_TARGET

class Cluster;
class Queue;

class Target {

 public:
  Target (Cluster * c, Queue * q);
  ~Target () {};
  bool operator! () const;
  int CalculateNeededFileSizes ();
  long long int GetNeededCacheSize () const;
  long long int GetNeededSessDirSize () const;
  long long int GetNeededTotalSize () const;
  long long int GetRemoteSize () const;
  long long int GetLocalSize () const;
  const Environment * FindEnvironment (const string & attr,
				       const EnvironmentTest & envtest) const;
  int Accept ();
  const string & GetArchitecture () const;
  int GetTotalCpus () const;
  int GetNodeMemory () const;
  int GetQueued () const;
  Cluster * cluster;
  Queue * queue;
  Xrsl xrsl;
 private:
  RemoteFileQuery query;
  long long int neededcachesize;
  long long int neededsessdirsize;
  long long int remotesize;
  long long int localsize;
};

#endif
